diff --git a/test/unit/tui/messages_test.rb b/test/unit/tui/messages_test.rb
index 322dce55..9a9f1ee0 100644
--- a/test/unit/tui/messages_test.rb
+++ b/test/unit/tui/messages_test.rb
@@ -67,6 +67,21 @@ class HiveTuiMessagesTest < Minitest::Test
     assert_includes Hive::Tui::Messages::OpenIdeaPreview.members, :row
   end
 
+  def test_idea_preview_loaded_carries_token_and_content
+    content = Object.new
+    msg = Hive::Tui::Messages::IdeaPreviewLoaded.new(token: 7, content: content)
+
+    assert_equal 7, msg.token
+    assert_same content, msg.content
+  end
+
+  def test_idea_preview_failed_carries_token_and_error
+    msg = Hive::Tui::Messages::IdeaPreviewFailed.new(token: 3, error: "boom")
+
+    assert_equal 3, msg.token
+    assert_equal "boom", msg.error
+  end
+
   def test_open_in_agent_carries_row
     row = Object.new
     msg = Hive::Tui::Messages::OpenInAgent.new(row: row)
diff --git a/test/unit/tui/model_test.rb b/test/unit/tui/model_test.rb
index efcf5716..8812ec9e 100644
--- a/test/unit/tui/model_test.rb
+++ b/test/unit/tui/model_test.rb
@@ -26,8 +26,7 @@ class HiveTuiModelTest < Minitest::Test
     assert_nil model.new_idea_staging_dir
     assert_nil model.new_idea_staging_tmp_root
     assert_equal [], model.new_idea_broken_labels
-    assert_nil model.idea_preview_text
-    assert_nil model.idea_preview_slug
+    assert_nil model.idea_preview_state
     assert_nil model.flash
     assert_nil model.flash_set_at
     assert_nil model.tail_state
@@ -65,17 +64,31 @@ class HiveTuiModelTest < Minitest::Test
     assert_equal 2, b.scope
   end
 
-  def test_with_updates_idea_preview_fields
+  def test_with_updates_idea_preview_state
+    row = Object.new
+    state = Hive::Tui::Model::IdeaPreviewState.new(row: row, token: 1, status: :loading)
     a = Hive::Tui::Model.initial
-    b = a.with(idea_preview_text: "original idea", idea_preview_slug: "ship-preview")
+    b = a.with(idea_preview_state: state)
 
-    assert_nil a.idea_preview_text
-    assert_nil a.idea_preview_slug
-    assert_equal "original idea", b.idea_preview_text
-    assert_equal "ship-preview", b.idea_preview_slug
+    assert_nil a.idea_preview_state
+    assert_same state, b.idea_preview_state
+    assert state.loading?
     refute_same a, b
   end
 
+  def test_idea_preview_state_status_predicates
+    row = Object.new
+    loading = Hive::Tui::Model::IdeaPreviewState.new(row: row, token: 1, status: :loading)
+    ready = loading.with(status: :ready)
+    error = loading.with(status: :error, error_message: "boom")
+
+    assert loading.loading?
+    refute loading.ready?
+    assert ready.ready?
+    assert error.error?
+    assert_equal "boom", error.error_message
+  end
+
   def test_model_is_immutable
     # Data.define records freeze themselves. Verify reassignment raises.
     model = Hive::Tui::Model.initial
@@ -129,7 +142,7 @@ class HiveTuiModelTest < Minitest::Test
     expected = %i[mode snapshot cursor filter filter_buffer scope pane_focus new_idea_project_name
                   new_idea_project_cursor new_idea_buffer new_idea_cursor
                   new_idea_attachments new_idea_staging_dir new_idea_staging_tmp_root new_idea_attachment_counter
-                  new_idea_broken_labels idea_preview_text idea_preview_slug flash flash_set_at
+                  new_idea_broken_labels idea_preview_state flash flash_set_at
                   tail_state red_status_detail_state
                   cols rows last_error]
     assert_equal expected, Hive::Tui::Model.members
diff --git a/test/unit/tui/update_test.rb b/test/unit/tui/update_test.rb
index 53fc23ab..b7e80fb9 100644
--- a/test/unit/tui/update_test.rb
+++ b/test/unit/tui/update_test.rb
@@ -254,6 +254,23 @@ class HiveTuiUpdateTest < Minitest::Test
     assert_match(/recovered/, new_model.flash)
   end
 
+  def test_snapshot_arrived_tracks_red_detail_task_across_stage_change
+    row = red_detail_row
+    starting = model.with(
+      mode: :red_status_detail,
+      red_status_detail_state: Hive::Tui::Model::RedStatusDetailState.new(row: row)
+    )
+    moved = row.with(stage: "7-finalize", folder: "/tmp/finalize/red-task")
+
+    new_model, _cmd = Hive::Tui::Update.apply(
+      starting,
+      Hive::Tui::Messages::SnapshotArrived.new(snapshot: snapshot_with_rows(moved))
+    )
+
+    assert_equal :red_status_detail, new_model.mode
+    assert_same moved, new_model.red_status_detail_state.row
+  end
+
   def test_snapshot_arrived_closes_red_detail_when_row_disappears
     row = red_detail_row
     starting = model.with(
@@ -1338,31 +1355,148 @@ class HiveTuiUpdateTest < Minitest::Test
     assert_equal :grid, new_model.mode
   end
 
-  def test_back_from_idea_preview_clears_text_and_returns_to_grid
+  def idea_preview_state(row:, token: 1, status: :loading, content: nil)
+    Hive::Tui::Model::IdeaPreviewState.new(
+      row: row, token: token, status: status, content: content
+    )
+  end
+
+  def test_back_from_idea_preview_clears_state_and_returns_to_grid
+    row = red_detail_row
     starting = model.with(
       mode: :idea_preview,
-      idea_preview_text: "original idea",
-      idea_preview_slug: "some-slug"
+      idea_preview_state: idea_preview_state(row: row)
     )
     new_model, _cmd = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::BACK)
 
     assert_equal :grid, new_model.mode
-    assert_nil new_model.idea_preview_text
-    assert_nil new_model.idea_preview_slug
+    assert_nil new_model.idea_preview_state
   end
 
-  def test_back_from_idea_preview_preserves_cursor_and_scope
+  def test_back_from_idea_preview_restores_captured_task_cursor
+    base = red_detail_row
+    rows = %w[first second third].each_with_index.map do |slug, i|
+      Hive::Tui::Snapshot::Row.new(
+        project_name: base.project_name, stage: base.stage, slug: slug,
+        folder: "/tmp/red-#{i}", state_file: "/tmp/red-#{i}/task.md",
+        marker: base.marker, attrs: base.attrs, mtime: nil, age_seconds: 0,
+        claude_pid: nil, claude_pid_alive: nil, action_key: base.action_key,
+        action_label: base.action_label, suggested_command: nil, next_action: nil,
+        diagnostic: base.diagnostic
+      )
+    end
+    snap = snapshot_with_rows(*rows)
+    # Open panel on middle row while cursor later drifts.
     starting = model.with(
       mode: :idea_preview,
-      idea_preview_text: "original idea",
-      idea_preview_slug: "some-slug",
-      cursor: [ 1, 2 ],
-      scope: 2
+      snapshot: snap,
+      cursor: [ 0, 0 ],
+      scope: 0,
+      idea_preview_state: idea_preview_state(row: rows[1], token: 2)
     )
     new_model, _cmd = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::BACK)
 
-    assert_equal [ 1, 2 ], new_model.cursor
-    assert_equal 2, new_model.scope
+    assert_equal :grid, new_model.mode
+    assert_equal [ 0, 1 ], new_model.cursor
+    assert_nil new_model.idea_preview_state
+  end
+
+  def test_back_from_idea_preview_restores_task_after_stage_change
+    original = red_detail_row
+    unrelated = original.with(slug: "other-task", folder: "/tmp/other-task")
+    moved = original.with(stage: "7-finalize", folder: "/tmp/finalize/red-task")
+    starting = model.with(
+      mode: :idea_preview,
+      snapshot: snapshot_with_rows(unrelated, moved),
+      cursor: [ 0, 0 ],
+      idea_preview_state: idea_preview_state(row: original, token: 3)
+    )
+
+    new_model, _cmd = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::BACK)
+
+    assert_equal :grid, new_model.mode
+    assert_equal [ 0, 1 ], new_model.cursor
+  end
+
+  def test_back_from_idea_preview_reclamps_when_task_removed
+    row = red_detail_row
+    other = Hive::Tui::Snapshot::Row.new(
+      project_name: "alpha", stage: "6-review", slug: "other-task", folder: "/tmp/other",
+      state_file: "/tmp/other/task.md", marker: "review_error", attrs: {}, mtime: nil,
+      age_seconds: 0, claude_pid: nil, claude_pid_alive: nil,
+      action_key: "recover_review", action_label: "Needs recovery", suggested_command: nil,
+      next_action: nil, diagnostic: nil
+    )
+    starting = model.with(
+      mode: :idea_preview,
+      snapshot: snapshot_with_rows(other),
+      cursor: [ 0, 0 ],
+      idea_preview_state: idea_preview_state(row: row, token: 1)
+    )
+    new_model, _cmd = Hive::Tui::Update.apply(starting, Hive::Tui::Messages::BACK)
+
+    assert_equal :grid, new_model.mode
+    assert_equal [ 0, 0 ], new_model.cursor
+  end
+
+  def test_idea_preview_loaded_matching_token_sets_ready_content
+    row = red_detail_row
+    content = Object.new
+    starting = model.with(
+      mode: :idea_preview,
+      idea_preview_state: idea_preview_state(row: row, token: 5)
+    )
+    new_model, cmd = Hive::Tui::Update.apply(
+      starting,
+      Hive::Tui::Messages::IdeaPreviewLoaded.new(token: 5, content: content)
+    )
+
+    assert_nil cmd
+    assert new_model.idea_preview_state.ready?
+    assert_same content, new_model.idea_preview_state.content
+  end
+
+  def test_idea_preview_loaded_stale_token_is_ignored
+    row = red_detail_row
+    starting = model.with(
+      mode: :idea_preview,
+      idea_preview_state: idea_preview_state(row: row, token: 5)
+    )
+    new_model, _cmd = Hive::Tui::Update.apply(
+      starting,
+      Hive::Tui::Messages::IdeaPreviewLoaded.new(token: 4, content: Object.new)
+    )
+
+    assert starting.idea_preview_state.loading?
+    assert_equal :loading, new_model.idea_preview_state.status
+    assert_nil new_model.idea_preview_state.content
+  end
+
+  def test_idea_preview_loaded_after_close_is_ignored
+    content = Object.new
+    starting = model.with(mode: :grid, idea_preview_state: nil)
+    new_model, _cmd = Hive::Tui::Update.apply(
+      starting,
+      Hive::Tui::Messages::IdeaPreviewLoaded.new(token: 1, content: content)
+    )
+
+    assert_equal :grid, new_model.mode
+    assert_nil new_model.idea_preview_state
+  end
+
+  def test_idea_preview_failed_matching_token_sets_error
+    row = red_detail_row
+    starting = model.with(
+      mode: :idea_preview,
+      idea_preview_state: idea_preview_state(row: row, token: 9)
+    )
+    new_model, _cmd = Hive::Tui::Update.apply(
+      starting,
+      Hive::Tui::Messages::IdeaPreviewFailed.new(token: 9, error: "disk full")
+    )
+
+    assert new_model.idea_preview_state.error?
+    assert_equal "disk full", new_model.idea_preview_state.error_message
   end
 
   def test_project_scope_sets_scope_and_resets_cursor
diff --git a/test/unit/tui/views/idea_preview_test.rb b/test/unit/tui/views/idea_preview_test.rb
index b18b8def..fa6679ee 100644
--- a/test/unit/tui/views/idea_preview_test.rb
+++ b/test/unit/tui/views/idea_preview_test.rb
@@ -1,59 +1,310 @@
 require "test_helper"
 require "hive/tui/model"
+require "hive/tui/snapshot"
+require "hive/tui/info_panel_content"
 require "hive/tui/views/idea_preview"
+require "unicode/display_width"
 
 class HiveTuiViewsIdeaPreviewTest < Minitest::Test
   include HiveTestHelper
 
-  def model_with(text: "Original idea", slug: "some-slug", cols: 80)
+  def make_row(slug: "some-slug", stage: "2-brainstorm", folder: "/tmp/hive/some-slug")
+    Hive::Tui::Snapshot::Row.new(
+      project_name: "demo", stage: stage, slug: slug, folder: folder,
+      state_file: "#{folder}/idea.md", marker: nil, attrs: {}, mtime: nil,
+      age_seconds: 0, claude_pid: nil, claude_pid_alive: nil,
+      action_key: "ready", action_label: "Ready", suggested_command: nil,
+      next_action: nil, diagnostic: nil
+    )
+  end
+
+  def make_content(**overrides)
+    defaults = {
+      slug: "some-slug",
+      stage: "2-brainstorm",
+      created_at: "2026-05-20T00:00:00Z",
+      created_at_available: true,
+      original_text: "Original idea",
+      original_text_available: true,
+      original_text_truncated: false,
+      task_folder: "/tmp/hive/some-slug",
+      latest_log_path: "/tmp/hive/.hive-state/logs/some-slug/run.log",
+      latest_log_available: true,
+      stage_extra_kind: :brainstorm,
+      stage_extra_label: "brainstorm.md",
+      stage_extra_text: "Brainstorm body",
+      stage_extra_available: true,
+      stage_extra_truncated: false
+    }
+    Hive::Tui::InfoPanelContent::Content.new(**defaults.merge(overrides))
+  end
+
+  def model_with(status: :ready, content: :default, row: nil, cols: 80, rows: 24, error_message: nil)
+    row ||= make_row
+    panel_content = content == :default ? make_content : content
+    state = Hive::Tui::Model::IdeaPreviewState.new(
+      row: row,
+      token: 1,
+      status: status,
+      content: panel_content,
+      error_message: error_message
+    )
     Hive::Tui::Model.initial.with(
       mode: :idea_preview,
-      idea_preview_text: text,
-      idea_preview_slug: slug,
-      cols: cols
+      idea_preview_state: state,
+      cols: cols,
+      rows: rows
     )
   end
 
   def render_lines(**kwargs)
-    Hive::Tui::Views::IdeaPreview.render(model_with(**kwargs), width: kwargs.fetch(:cols, 80)).lines(chomp: true)
+    model = model_with(**kwargs)
+    Hive::Tui::Views::IdeaPreview.render(
+      model,
+      width: kwargs.fetch(:cols, 80),
+      height: kwargs.fetch(:rows, 24)
+    ).lines(chomp: true)
   end
 
-  def test_renders_header_with_slug
-    out = Hive::Tui::Views::IdeaPreview.render(model_with(slug: "preview-me"))
-    assert_includes out, "Idea for preview-me:"
-  end
+  def counted_text(text)
+    Class.new(String) do
+      attr_reader :lines_yielded
+
+      def to_s
+        self
+      end
 
-  def test_renders_original_text_verbatim
-    out = Hive::Tui::Views::IdeaPreview.render(model_with(text: "keep [image1] plain"))
-    assert_includes out, "keep [image1] plain"
+      def each_line(*args, **kwargs, &block)
+        return enum_for(__method__, *args, **kwargs) unless block
+
+        @lines_yielded = 0
+        super(*args, **kwargs) do |line|
+          @lines_yielded += 1
+          block.call(line)
+        end
+      end
+    end.new(text)
   end
 
-  def test_renders_dismiss_hint
+  def test_ready_brainstorm_renders_common_fields_and_extra
     out = Hive::Tui::Views::IdeaPreview.render(model_with)
-    assert out.end_with?(Hive::Tui::Views::IdeaPreview::DISMISS_HINT),
-           "dismiss hint must be the final rendered line"
+    assert_includes out, "Info · some-slug"
+    assert_includes out, "slug: some-slug"
+    assert_includes out, "stage: 2-brainstorm"
+    assert_includes out, "created_at: 2026-05-20T00:00:00Z"
+    assert_includes out, "Original idea"
+    assert_includes out, "task folder:"
+    assert_includes out, "latest log:"
+    assert_includes out, "brainstorm.md"
+    assert_includes out, "Brainstorm body"
+  end
+
+  def test_ready_execute_renders_execute_log_tail
+    c = make_content(
+      stage: "4-execute",
+      stage_extra_kind: :execute_log,
+      stage_extra_label: "execute log",
+      stage_extra_text: "exec line 1\nexec line 2",
+      stage_extra_available: true
+    )
+    out = Hive::Tui::Views::IdeaPreview.render(model_with(content: c, row: make_row(stage: "4-execute")))
+    assert_includes out, "latest log:"
+    assert_includes out, "execute log"
+    assert_includes out, "exec line 1"
+  end
+
+  def test_inbox_omits_stage_extra_heading
+    c = make_content(
+      stage: "1-inbox",
+      stage_extra_kind: nil,
+      stage_extra_label: nil,
+      stage_extra_text: "",
+      stage_extra_available: false
+    )
+    out = Hive::Tui::Views::IdeaPreview.render(model_with(content: c, row: make_row(stage: "1-inbox")))
+    refute_includes out, "brainstorm.md"
+    refute_includes out, "plan.md"
+    refute_includes out, "execute log"
+    assert_includes out, "slug: some-slug"
+  end
+
+  def test_loading_state_is_full_screen_with_close_footer
+    lines = render_lines(status: :loading, content: nil)
+    joined = lines.join("\n")
+    assert_includes joined, "Loading info"
+    assert_equal Hive::Tui::Views::IdeaPreview::CLOSE_FOOTER, lines.last
+  end
+
+  def test_loading_label_fits_narrow_viewport
+    lines = render_lines(status: :loading, content: nil, cols: 5, rows: 3)
+
+    assert lines.all? { |line| Unicode::DisplayWidth.of(line) <= 5 }, lines.inspect
   end
 
-  def test_truncates_long_lines_to_width
-    lines = render_lines(text: "x" * 80, cols: 20)
+  def test_unavailable_fields_labeled
+    c = make_content(
+      created_at: nil,
+      created_at_available: false,
+      latest_log_path: nil,
+      latest_log_available: false,
+      stage_extra_kind: :plan,
+      stage_extra_label: "plan.md",
+      stage_extra_text: "",
+      stage_extra_available: false
+    )
+    out = Hive::Tui::Views::IdeaPreview.render(model_with(content: c))
+    assert_includes out, "created_at: unavailable"
+    assert_includes out, "latest log: unavailable"
+    assert_includes out, "plan.md"
+    assert_includes out, "unavailable"
+  end
 
+  def test_long_lines_wrap_within_width
+    c = make_content(original_text: "x" * 80)
+    lines = render_lines(content: c, cols: 20, rows: 40)
     assert lines.all? { |line| line.length <= 20 },
            "all rendered lines must fit width: #{lines.inspect}"
   end
 
-  def test_caps_visible_rows_for_oversized_text
-    text = (1..10).map { |i| "line #{i}" }.join("\n")
-    lines = render_lines(text: text)
-    body_lines = lines[1...-1]
+  def test_wide_task_text_wraps_by_terminal_cell_width_without_loss
+    original_text = "漢字🙂alpha"
+    c = make_content(original_text: original_text)
+
+    lines = render_lines(content: c, cols: 6, rows: 40)
+
+    assert lines.all? { |line| Unicode::DisplayWidth.of(line) <= 6 }, lines.inspect
+    assert_includes lines.join, original_text
+  end
+
+  def test_failed_load_message_wraps_within_viewport
+    lines = render_lines(
+      status: :error,
+      content: nil,
+      error_message: "MalformedArtifact: #{"界" * 20}",
+      cols: 8,
+      rows: 10
+    )
+
+    assert_operator lines.length, :<=, 10
+    assert lines.all? { |line| Unicode::DisplayWidth.of(line) <= 8 }, lines.inspect
+  end
+
+  def test_partial_load_error_note_wraps_within_viewport
+    lines = render_lines(
+      status: :error,
+      error_message: "PartialArtifact: #{"界" * 20}",
+      cols: 8,
+      rows: 40
+    )
 
-    assert_operator body_lines.length, :<=, Hive::Tui::Views::IdeaPreview::MAX_VISIBLE_ROWS
+    assert lines.all? { |line| Unicode::DisplayWidth.of(line) <= 8 }, lines.inspect
   end
 
-  def test_handles_nil_text_gracefully
-    lines = render_lines(text: nil, slug: "nil-text")
+  def test_absolute_paths_wrap_without_losing_content
+    task_path = "/tmp/a-very-long-project-name/.hive-state/stages/2-brainstorm/some-slug"
+    log_path = "/tmp/a-very-long-project-name/.hive-state/logs/some-slug/brainstorm-latest.log"
+    c = make_content(task_folder: task_path, latest_log_path: log_path)
+
+    out = render_lines(content: c, cols: 20, rows: 80).join("\n")
+    flattened = out.delete("\n")
 
-    assert_equal 2, lines.length
-    assert_includes lines.first, "Idea for nil-text:"
-    assert_equal Hive::Tui::Views::IdeaPreview::DISMISS_HINT, lines.last
+    assert_includes flattened, "task folder: #{task_path}"
+    assert_includes flattened, "latest log: #{log_path}"
+  end
+
+  def test_long_markdown_heading_wraps_without_losing_content
+    heading = "Heading content that must survive wrapping"
+    c = make_content(stage_extra_text: "# #{heading}")
+
+    out = render_lines(content: c, cols: 16, rows: 60).join("\n").delete("\n")
+
+    assert_includes out, heading
+  end
+
+  def test_markdown_wrapping_stops_at_requested_line_limit
+    dense = (1..10_000).map { |i| "line #{i}" }.join("\n")
+
+    wrapped = Hive::Tui::Views::IdeaPreviewLayout.wrap_markdown(dense, 80, limit: 5)
+
+    assert_equal 5, wrapped.length
+    assert_equal "line 5", wrapped.last
+  end
+
+  def test_chunk_iteration_stops_at_limit_for_single_oversized_line
+    chunks = []
+    line = "x" * Hive::Tui::InfoPanelContent::MARKDOWN_BYTE_CAP
+
+    Hive::Tui::Views::IdeaPreviewLayout.each_chunk(line, 80, limit: 5) do |chunk|
+      chunks << chunk
+    end
+
+    assert_equal 5, chunks.length
+    assert chunks.all? { |chunk| chunk == "x" * 80 }
+  end
+
+  def test_render_bounds_iteration_for_idea_and_stage_artifact
+    dense = (1..10_000).map { |i| "line #{i}" }.join("\n")
+    idea = counted_text(dense)
+    stage_extra = counted_text(dense)
+    c = make_content(original_text: idea, stage_extra_text: stage_extra)
+
+    render_lines(content: c, cols: 80, rows: 10)
+
+    wrap_limit = 10 - 2 + 1
+    assert_operator idea.lines_yielded, :<=, wrap_limit
+    assert_operator stage_extra.lines_yielded, :<=, wrap_limit
+  end
+
+  def test_vertical_overflow_ends_with_ellipsis_and_keeps_footer
+    long_body = (1..100).map { |i| "line #{i}" }.join("\n")
+    c = make_content(original_text: long_body, stage_extra_text: long_body)
+    lines = render_lines(content: c, cols: 80, rows: 10)
+    assert_equal Hive::Tui::Views::IdeaPreview::CLOSE_FOOTER, lines.last
+    assert_includes lines, "…"
+    assert_operator lines.length, :<=, 10
+    assert lines.any? { |line| line.start_with?("task folder:") }
+    assert lines.any? { |line| line.start_with?("latest log:") }
+    assert lines.any? { |line| line.include?("brainstorm.md") }
+  end
+
+  def test_very_short_overflow_keeps_paths_and_stage_section
+    long_body = (1..100).map { |i| "line #{i}" }.join("\n")
+    c = make_content(original_text: long_body, stage_extra_text: long_body)
+
+    [ 8, 9 ].each do |height|
+      lines = render_lines(content: c, cols: 80, rows: height)
+
+      assert_operator lines.length, :<=, height
+      assert lines.any? { |line| line.start_with?("task folder:") }, height
+      assert lines.any? { |line| line.start_with?("latest log:") }, height
+      assert lines.any? { |line| line.include?("brainstorm.md") }, height
+      assert_includes lines[-2], "…", height
+    end
+  end
+
+  def test_source_truncation_adds_visible_marker
+    c = make_content(original_text_truncated: true)
+
+    lines = render_lines(content: c, cols: 80, rows: 24)
+
+    assert_includes lines, "  …"
+  end
+
+  def test_sanitizes_control_and_ansi_sequences
+    dirty = "hello\e[31mRED\e[0m\x07world\u0085after".b
+    c = make_content(original_text: dirty, stage_extra_text: dirty)
+    out = Hive::Tui::Views::IdeaPreview.render(model_with(content: c))
+    refute_includes out, "\e["
+    refute_includes out, "\x07"
+    refute_includes out, "\u0085"
+    assert_includes out, "hello"
+    assert_includes out, "world"
+    assert_includes out, "after"
+  end
+
+  def test_close_footer_always_present
+    out = Hive::Tui::Views::IdeaPreview.render(model_with)
+    assert out.end_with?(Hive::Tui::Views::IdeaPreview::CLOSE_FOOTER),
+           "close footer must be final line"
   end
 end
